<?php

namespace Util;

use Zeedhi\Framework\DataSource\FilterCriteria;

class ConditionsQuery {

    public static function dictionaryLogicalToSql($operator){        
        switch($operator){
            case "==": $operator = FilterCriteria::EQ;
                break;
            case "!=": $operator = FilterCriteria::NEQ;
                break;
            case ">" : $operator = FilterCriteria::GT;
                break;
            case ">=": $operator = FilterCriteria::GTE;
                break;
            case "<" : $operator = FilterCriteria::LT;
                break; 
            case "<=": $operator = FilterCriteria::LTE;
                break;
            case "&&": $operator = "AND";
                break;
            case "||": $operator = "OR";    
                break;    
                default: $operator;
            }
            return $operator;
    }
        
    public static function buildComparisonArray($conditions) {
            $conditions['expressions'][0] = $conditions['firstValue'];
            $conditions['expressions'][1] = $conditions['secondValue'];
            unset($conditions['firstValue']);
            unset($conditions['secondValue']);            
            return $conditions;
    }
    
    public static function convertLogicalToSqlSentence($conditions) {
        $convertedCondition = "";
        if($conditions['operator'] === "&&"){
            $conditions = ConditionsQuery::buildComparisonArray($conditions);
        }
        if(isset($conditions['expressions'])){
            if($conditions['operator']){
                $outOperator =  ConditionsQuery::dictionaryLogicalToSql($conditions['operator']);
            }
            
            foreach($conditions['expressions'] as $index =>  $expression){
                if(is_array($expression['firstValue'])){
                    $expression['firstValue'] = ConditionsQuery::convertLogicalToSqlSentence($expression['firstValue']);
                }
                if(is_array($expression['secondValue'])){
                    $expression['secondValue'] = ConditionsQuery::convertLogicalToSqlSentence($expression['secondValue']);
                }else{
                    $expression['secondValue'] = ' \''.$expression['secondValue'].'\'';
                }
                $convertedCondition .=  $expression['firstValue'].' '.
                ConditionsQuery::dictionaryLogicalToSql($expression['operator']).
                ' '.$expression['secondValue'].' '.$outOperator.' ';
            }
            $convertedCondition = $outOperator == "OR" ? substr($convertedCondition, 0, -3) : substr($convertedCondition, 0, -4);
        } else {
            $newOperator = ConditionsQuery::dictionaryLogicalToSql($conditions['operator']);
            if(is_numeric($conditions['secondValue'])){
                $convertedCondition = $conditions['firstValue'].' '.$newOperator.' '.$conditions['secondValue'];
            } else {
                $convertedCondition = $conditions['firstValue'].' '.$newOperator.' \''.$conditions['secondValue'].'\'';                
            }
        }
        return $convertedCondition;
    }

}
?>