create or replace
PROCEDURE IMPORTA_INSCRESTAD
IS
   V_CDEMPRESA   INTEGER;
   V_CDPAIS      INTEGER;
   V_SGESTADO    INTEGER;
   V_CDMUNICIPIO VARCHAR2(4);
   V_INSCRESTAD  INTEGER;
   V_MUNICIPIO   INTEGER;

BEGIN
   FOR C_INSCRESTAD IN
      (SELECT U.CDEMPRESA, U.CDINSCESTA, U.IDTPIJURIEST, U.NRINSJURIEST, U.CDPAIS, U.SGESTADO,
              U.CDMUNICIPIO, U.DSENDEIEST, U.CDBAIRRO, U.NRCEPIEST, U.IDINTERFACE, U.TPINTERFACE
         FROM USR_SAP_INSCESTA U
        WHERE U.DTINTERFACEDEST IS NULL)
   LOOP
      SELECT COUNT(*)
        INTO V_CDEMPRESA
        FROM EMPRESA
       WHERE CDEMPRESA = C_INSCRESTAD.CDEMPRESA;
      IF V_CDEMPRESA > 0 THEN
         SELECT COUNT(*)
           INTO V_INSCRESTAD
           FROM INSCRESTAD
          WHERE CDEMPRESA  = C_INSCRESTAD.CDEMPRESA
            AND CDINSCESTA = C_INSCRESTAD.CDINSCESTA;
         IF V_INSCRESTAD = 0 THEN
            SELECT COUNT(*)
              INTO V_CDPAIS
              FROM PAIS
             WHERE CDPAIS = C_INSCRESTAD.CDPAIS;
            IF V_CDPAIS > 0 THEN
               SELECT COUNT(*)
                 INTO V_SGESTADO
                 FROM ESTADO
                WHERE CDPAIS = C_INSCRESTAD.CDPAIS
                  AND SGESTADO = C_INSCRESTAD.SGESTADO;
               IF V_SGESTADO > 0 THEN
                  BEGIN
                     SELECT COUNT(*) AS CONTADOR, CDMUNICIPIO
                       INTO V_MUNICIPIO, V_CDMUNICIPIO
                       FROM MUNICIPIO
                      WHERE CDPAIS = C_INSCRESTAD.CDPAIS
                        AND SGESTADO = C_INSCRESTAD.SGESTADO
                        AND CDMUNICIBGE = C_INSCRESTAD.CDMUNICIPIO
                      GROUP BY CDMUNICIPIO;
                     IF V_MUNICIPIO > 0 THEN
                        IF C_INSCRESTAD.IDTPIJURIEST IN ('F','J','I','O') THEN 
                           INSERT INTO INSCRESTAD(CDEMPRESA, CDINSCESTA, IDTPIJURIEST, NRINSJURIEST, CDPAIS,
                                                  SGESTADO, CDMUNICIPIO, DSENDEIEST, NMBAIRIEST, NRCEPIEST)
                           VALUES (C_INSCRESTAD.CDEMPRESA, C_INSCRESTAD.CDINSCESTA, C_INSCRESTAD.IDTPIJURIEST, C_INSCRESTAD.NRINSJURIEST, C_INSCRESTAD.CDPAIS,
                                   C_INSCRESTAD.SGESTADO, V_CDMUNICIPIO, C_INSCRESTAD.DSENDEIEST, C_INSCRESTAD.CDBAIRRO, C_INSCRESTAD.NRCEPIEST);
                           INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                           VALUES(C_INSCRESTAD.IDINTERFACE, 'I', 13, SYSDATE, 1, 'Inscri'||CHR(231)||''||CHR(227)||'o Estadual '|| C_INSCRESTAD.CDINSCESTA ||' cadastrada com sucesso.');
                           
                           UPDATE USR_SAP_INSCESTA SET DTINTERFACEDEST = SYSDATE, STATUS = 0
                            WHERE IDINTERFACE   = C_INSCRESTAD.IDINTERFACE;
                        ELSE
                           INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                           VALUES (C_INSCRESTAD.IDINTERFACE, 'I', 13, SYSDATE, 1, 'Tipo de cadastro '|| C_INSCRESTAD.IDTPIJURIEST||' n'||CHR(227)||'o  valido.');

                           UPDATE USR_SAP_INSCESTA SET STATUS = 2
                            WHERE IDINTERFACE   = C_INSCRESTAD.IDINTERFACE;
                        END IF;
                     END IF;
                  EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_CDMUNICIPIO := '';
                        INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                        VALUES (C_INSCRESTAD.IDINTERFACE, 'I', 13, SYSDATE, 1, 'C'||CHR(243)||'digo do munic'||CHR(237)||'pio IBGE '|| C_INSCRESTAD.CDMUNICIPIO||' n'||CHR(227)||'o cadastrado no sistema Teknisa.');

                        UPDATE USR_SAP_INSCESTA SET STATUS = 2
                         WHERE IDINTERFACE   = C_INSCRESTAD.IDINTERFACE;
                  END;
               ELSE
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES (C_INSCRESTAD.IDINTERFACE, 'I', 13, SYSDATE, 1, 'Estado '|| C_INSCRESTAD.SGESTADO ||' n'||CHR(227)||'o cadastrado no sistema Teknisa.');

                  UPDATE USR_SAP_INSCESTA SET STATUS = 2
                   WHERE IDINTERFACE   = C_INSCRESTAD.IDINTERFACE;
               END IF;
            ELSE
               INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
               VALUES (C_INSCRESTAD.IDINTERFACE, 'I', 13, SYSDATE, 1, 'Pa'||CHR(237)||'s '|| C_INSCRESTAD.CDPAIS ||' n'||CHR(227)||'o cadastrado no sistema Teknisa.');

               UPDATE USR_SAP_INSCESTA SET STATUS = 2
                WHERE IDINTERFACE   = C_INSCRESTAD.IDINTERFACE;
            END IF;
         ELSE
            INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
            VALUES (C_INSCRESTAD.IDINTERFACE, 'I', 13, SYSDATE, 1, 'Inscri'||CHR(231)||''||CHR(227)||'o Estadual '|| C_INSCRESTAD.CDINSCESTA ||' j est cadastrada no sistema Teknisa.');

            UPDATE USR_SAP_INSCESTA SET STATUS = 2
             WHERE IDINTERFACE   = C_INSCRESTAD.IDINTERFACE;
         END IF;
	  ELSE
         INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
         VALUES (C_INSCRESTAD.IDINTERFACE, 'I', 13, SYSDATE, 1, 'Empresa '|| C_INSCRESTAD.CDEMPRESA ||' n'||CHR(227)||'o cadastrada no sistema Teknisa.');

         UPDATE USR_SAP_INSCESTA SET STATUS = 2
          WHERE IDINTERFACE   = C_INSCRESTAD.IDINTERFACE;
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_INSCRESTAD','5.42.XXX'); END;
/