import Vue from 'vue';
import Zeedhi from '@zeedhi/vue';
import ZeedhiComponents from '@zeedhi/vuetify';
import TeknisaComponents from '@zeedhi/teknisa-components-vuetify';
import { Icons } from '@zeedhi/common';
import { Messages } from '@zeedhi/core';
import { ZdHighlight } from '@zeedhi/zd-highlight-vue';
import { ZdSkeletonLoader } from '@zeedhi/zd-skeletonloader';
import router from '../router';
import controllers from '../controllers';
import config from '../config/config';
import '@zeedhi/common/dist/style.css';
import '@zeedhi/vuetify/dist/zd-style.css';
import vuetify from './vuetify';

Icons.addIcons({
  iconName: 'mdi-icon-id',
});

Vue.component('ZdHighlight', ZdHighlight);

Vue.use(Zeedhi, {
  controllers,
  router,
  config,
});
Vue.use(ZeedhiComponents);
Vue.use(TeknisaComponents);

vuetify.framework.icons.values = Icons.getIcons() as any;

Vue.component('ZdHighlight', ZdHighlight);
Vue.component('ZdSkeletonLoader', ZdSkeletonLoader);

Messages.add({
  'pt-BR': {
    translation: {
      ALE_LOGOUT: 'Deseja realmente sair do sistema?',
    },
  },
  'es-CL': {
    translation: {
      KEY: 'valor',
    },
  },
  'es-CO': {
    translation: {
      KEY: 'valor',
    },
  },
  'es-ES': {
    translation: {
      KEY: 'valor',
    },
  },
  'en-US': {
    translation: {
      KEY: 'value',
    },
  },
});
